> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# List elements in a data model

GET https://api.sigmacomputing.com/v2/dataModels/{dataModelId}/elements

This endpoint retrieves details of all elements in a data model, which helps you understand and interact with the individual components that make up the data model, such as tables or controls.
### Usage notes
- Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.
- To retrieve elements from version-tagged data models, pass the `tagName` in the query parameters with the tag name. Retrieve the tag name by calling the [/v2/dataModels/{dataModelId}/tags](https://help.sigmacomputing.com/reference/list-data-model-tags) endpoint and using the `tags.name` included in the response for a given data model.
### Usage scenarios
- **Detailed analysis:** Developers and users can retrieve specific elements for detailed data analysis or further manipulation.
- **Interface customization:** Allows for dynamic interface construction where users can choose which elements to display or interact with.
### Best practices
- Use pagination to handle large numbers of elements efficiently, reducing load times and improving user experience.

Reference: https://help.sigmacomputing.com/reference/list-data-model-elements

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/dataModels/{dataModelId}/elements:
    get:
      operationId: listDataModelElements
      summary: List elements in a data model
      description: >-
        This endpoint retrieves details of all elements in a data model, which
        helps you understand and interact with the individual components that
        make up the data model, such as tables or controls.

        ### Usage notes

        - Retrieve the **dataModelId** by calling the
        [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models)
        endpoint.

        - To retrieve elements from version-tagged data models, pass the
        `tagName` in the query parameters with the tag name. Retrieve the tag
        name by calling the
        [/v2/dataModels/{dataModelId}/tags](https://help.sigmacomputing.com/reference/list-data-model-tags)
        endpoint and using the `tags.name` included in the response for a given
        data model.

        ### Usage scenarios

        - **Detailed analysis:** Developers and users can retrieve specific
        elements for detailed data analysis or further manipulation.

        - **Interface customization:** Allows for dynamic interface construction
        where users can choose which elements to display or interact with.

        ### Best practices

        - Use pagination to handle large numbers of elements efficiently,
        reducing load times and improving user experience.
      tags:
        - dataModels
      parameters:
        - name: dataModelId
          in: path
          required: true
          schema:
            type: string
        - name: page
          in: query
          required: false
          schema:
            type: string
        - name: limit
          in: query
          required: false
          schema:
            type: number
            format: double
        - name: tagName
          in: query
          required: false
          schema:
            type: string
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/dataModels_listDataModelElements_Response_200
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2DataModelsDataModelIdElementsGetResponsesContentApplicationJsonSchemaEntriesItems:
      type: object
      properties:
        elementId:
          type: string
        name:
          type: string
        type:
          type: string
        columns:
          type: array
          items:
            type: string
        vizualizationType:
          type: string
        error:
          type: string
      required:
        - elementId
      title: >-
        V2DataModelsDataModelIdElementsGetResponsesContentApplicationJsonSchemaEntriesItems
    dataModels_listDataModelElements_Response_200:
      type: object
      properties:
        entries:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2DataModelsDataModelIdElementsGetResponsesContentApplicationJsonSchemaEntriesItems
        nextPage:
          type:
            - string
            - 'null'
        total:
          type: number
          format: double
      required:
        - entries
        - nextPage
      title: dataModels_listDataModelElements_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{
  "entries": [
    {
      "elementId": "tbl_9f8b7c6d5e4a3b2c1d0e",
      "name": "Sales Orders",
      "type": "table",
      "columns": [
        "OrderID",
        "CustomerID",
        "OrderDate",
        "TotalAmount"
      ],
      "vizualizationType": "table",
      "error": null
    },
    {
      "elementId": "ctrl_4a3b2c1d0e9f8b7c6d5e",
      "name": "Date Filter",
      "type": "control",
      "columns": [],
      "vizualizationType": "date-picker",
      "error": null
    },
    {
      "elementId": "tbl_1a2b3c4d5e6f7g8h9i0j",
      "name": "Customer Details",
      "type": "table",
      "columns": [
        "CustomerID",
        "CustomerName",
        "Region",
        "Email"
      ],
      "vizualizationType": "table",
      "error": null
    }
  ],
  "nextPage": "eyJwYWdlIjoiMg==",
  "total": 3
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements"

payload = {}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements';
const options = {
  method: 'GET',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```